# openCARP executables directory
# Specify as many alternative directories as you like, and use the key (e.g.
# 'CPU'/'GPU') with the --build flag on the command line to select which one
# to run with. Whether the build uses GPU or not is determined automatically.
CARP_EXE_DIR: {CARP_EXE_DIR}

# Other paths
MESHALYZER_DIR: {MESHALYZER_DIR}
LIMPETGUI_DIR:  {LIMPETGUI_DIR}
MESH_DIR:       {MESH_DIR}
MESHTOOL_DIR:   {MESHTOOL_DIR}
# Path to the directory containing the openCARP source files
OPENCARP_SRC:   {OPENCARP_SRC}

# Execution settings and configuration defaults
# Some of these can be overridden on the command line
MPIEXEC:       {MPIEXEC:<10s} # Affects desktop only
SILENT:        {SILENT:<10s} # choose Yes or No
VISUALIZE:     {VISUALIZE:<10s} # visualization default (Yes, No)
FLAVOR:        {FLAVOR:<10s} # choose petsc, direct or pt
DIRECT_SOLVER: {DIRECT_SOLVER:<10s} # choose MUMPS, SUPERLU_DIST or PASTIX
PURK_SOLVER:   {PURK_SOLVER:<10s} # choose GMRES, MUMPS, SUPERLU_DIST or PASTIX
PLATFORM:      {PLATFORM:<10s} # choose default hardware profile
BUILD:         {BUILD:<10s} # choose default CARP build (CPU, GPU)

# Regression testing settings

# The path to a directory containing the reference solution repositories
# (required):
REGRESSION_REF: {REGRESSION_REF}

# Default packages to run tests from (can use the Python subpackage notation
# to select specific submodules, e.g. devtests.mechanics):
REGRESSION_PKG: {REGRESSION_PKG}
# Examples
#    - devtests
#    - benchmarks
#    - devtests.mechanics # Would cause duplication with full devtests above

# Uncomment the following line to control the location of temporary
# files generated by the regression testing framework. By default, temporary
# files are generated in your system /tmp
# REGRESSION_TEMP: {REGRESSION_TEMP}

# Uncomment to limit resources
# MAX_NP:      {MAX_NP:<10} # set maximum number of processes

# Personal information
EMAIL: {EMAIL} # Email for notifications
NAME: {NAME} # Name of the user
ORCID: {ORCID} # ORCID of the user
